#include<stdio.h>
#include<stdlib.h>
#include"string.h"
#include<kos32sys.h>
#include<mgtk/app.h>

void MGTK_Init(void);

extern "C" char * strdup(char *);

static char * std_app_title="MGTK Application";

static inline void read_mouse(int * x,int * y,int * b)
{
 int v;
 __asm__ __volatile__("int $0x40":"=a"(v):"0"(37),"b"(1));
 *y=(v&0xffff);
 *x=v>>16;
 if((*x)<0 || (*x)>10000) (*x)=0;
 if((*y)<0 || (*y)>10000) (*y)=0;
 __asm__ __volatile__("int $0x40":"=a"(v):"0"(37),"b"(2));
 *b=v;
}

GApplication::GApplication(GRect * r):GGroup()
{
 MGTK_Init();
 Flags=wf_Visible;
 Caption=std_app_title;
 Size.x=r->w;
 Size.y=r->h;
 Origin.x=6;
 Origin.y=25;
 priv_origin.x=r->x; 
 priv_origin.y=r->y; 
 priv_size.x=r->w+12;
 priv_size.y=r->h+30;
}

GApplication::~GApplication()
{
 this->GGroup::~GGroup();
}

void GApplication::SetCaption(char * cap)
{
 if(Caption==std_app_title) return;
 free(Caption);
 if(!cap)
 {
  Caption=std_app_title;
  return;
 }
 Caption=strdup(cap);
}

#define EVM_REDRAW        1
#define EVM_KEY           2
#define EVM_BUTTON        4
#define EVM_EXIT          8
#define EVM_BACKGROUND    16
#define EVM_MOUSE         32
#define EVM_IPC           64
#define EVM_STACK         128
#define EVM_DEBUG         256
#define EVM_STACK2        512
#define EVM_MOUSE_FILTER  0x80000000
#define EVM_CURSOR_FILTER 0x40000000

void GApplication::Init(void)
{
 body=0x03000000|RGB(236,233,216);
 grab=0x00000080;
 frame=RGB(95,85,0);
 set_wanted_events_mask(7|EVM_MOUSE);
}

void GApplication::Run(void)
{
 int i;
 GEvent ev;
 GPoint m,n;
 int b;
 m.x=0;
 m.y=0;
 n.x=0;
 n.y=0;
 b=0;
 BeginDraw();
 DrawWidget();
 EndDraw();
 for(;;)
 {
  ClearEvent(&ev);
  if(!WFirst)
   i=wait_for_event(1);
  else {
   delay(3);
   i=check_os_event();
  }
  ev.evType=GEVENT_COMMAND;
  switch(i)
  {
   case 0:
    ev.evType=GEVENT_IDLE;
    break;
   case 1:
    BeginDraw();
    DrawWidget();
    EndDraw();
    continue;
   case 2:
    ev.evType=GEVENT_KEYBOARD;
    //ev.type.key.keyId=get_key();
    break;
   case 3:
    ev.evType=GEVENT_BUTTON;
    ev.type.button.butId=get_os_button();
    if(ev.type.button.butId==1)
    {
     ev.evType=GEVENT_COMMAND;
     ev.type.command.evCommand=cm_Quit;
     HandleEvent(&ev);
     return;
    }
    break;
   case 6:
    read_mouse(&n.x,&n.y,&b);
    ev.type.mouse.bMouse=b;
    ev.type.mouse.xMouse=m.x;
    ev.type.mouse.yMouse=m.y;
    if(b!=0)
    {
     ev.evType=GEVENT_CLICK;
    } else if(m.x!=n.x || m.y!=n.y)
    {
     m.x=n.x;
     m.y=n.y;
     ev.evType=GEVENT_MOUSE;
    }
    break;
   default:
    continue;
  }
  HandleEvent(&ev);
 }
}

void GApplication::Done(void)
{
}

void GApplication::DrawWidget(void)
{
 DrawWindow(priv_origin.x,priv_origin.y,priv_size.x,priv_size.y,std_app_title,body,/*grab,frame,*/ 0x33);
 draw_text_sys(Caption, 7,6, strlen(Caption), 0x10ffffff);
 this->GGroup::DrawWidget();
 delay(3);
}
