#include<mgtk/button.h>
#include<kos32sys.h>

GButton::GButton(GRect * r,int flags,unsigned long color,int cmd):GWidget()
{
 SetBounds(r);
 bId=OSButtonAlloc->New();
 bFlags=flags;
 bColor=color&0xffffff;
 bCmd=cmd;
 if(bFlags&bs_DontDraw) bColor|=0x40000000;
}

GButton::~GButton()
{
 if(!(wf_Disabled&Flags))
  define_button(0, 0,bId,0x80000000);
 OSButtonAlloc->Del(bId);
}

void GButton::HandleEvent(GEvent * event)
{
 GWidget::HandleEvent(event);
 if(!(wf_Disabled&Flags) && event->evType==GEVENT_COMMAND &&
    event->type.command.evCommand==cm_Disable)
 {
  define_button(0, 0,bId,0x80000000);
  Flags|=wf_Disabled;
  ClearEvent(event);
  return;
 }
 if((wf_Disabled&Flags) && event->evType==GEVENT_COMMAND &&
    event->type.command.evCommand==cm_Enable)
 {
  GPoint p;
  p.x=0;
  p.y=0;
  ToGlobal(&p);
  define_button(65536 * p.x + Size.x, 65536 * p.y + Size.y,bId,bColor);
  Flags&=~wf_Disabled;
  ClearEvent(event);
  return;
 }
 if(Flags&wf_Disabled) return;
 if(event->evType==GEVENT_BUTTON && bId==event->type.button.butId)
 {
  ClickProc();
  event->evType=GEVENT_COMMAND;
  event->type.command.evCommand=bCmd;
  event->type.command.info=(void *)this;
  Parent->BroadcastEvent(event);
  ClearEvent(event);
  return;
 }
}

void GButton::DrawWidget(void)
{
 GPoint p;
 p.x=0;
 p.y=0;
 ToGlobal(&p);
 define_button(65536 * p.x + Size.x, 65536 * p.y + Size.y,bId,bColor);
}

void GButton::ClickProc(void)
{
}

void GButton::SetCommand(int cmd)
{
 bCmd=cmd;
}
