#include<mgtk/button.h>
#include<stdio.h>
#include<stdlib.h>
#include"string.h"

GButtonAllocator * OSButtonAlloc=NULL;

void MGTK_InitButtonAllocator(void)
{
 OSButtonAlloc=new GButtonAllocator(1024);
}

GButtonAllocator::GButtonAllocator(int max)
{
 max=(max+7)&~7;
 nr_buttons=max; 
 gbutton_bitmap=(unsigned char *)malloc(max/8);
 memset(gbutton_bitmap,0,max/8);
 gbutton_bitmap[0]=0xff; /* Protect first 8 buttons */
}

GButtonAllocator::~GButtonAllocator()
{
 free((void *)gbutton_bitmap);
}

int GButtonAllocator::New(void)
{
 int i,j;
 for(i=0;i<nr_buttons/8;i++)
  for(j=0;j<8;j++)
   if(!(gbutton_bitmap[i]&(1<<j)))
   {
    gbutton_bitmap[i]|=(1<<j);
    return (i*8)+j;
   }
 return 0; /* Shouldn't happen */
}

void GButtonAllocator::Del(int i)
{
 int j;
 if(i<6 || i>=nr_buttons) return;
 j=~(1<<(i%8));
 i/=8;
 gbutton_bitmap[i]&=j;
}
