#include<stdio.h>
#include<stdlib.h>
#include<mgtk/widget.h>

GGroup::GGroup():GWidget()
{
 WNext=NULL;
 WPrev=NULL;
 WFirst=NULL;
}

GGroup::~GGroup()
{
 GWidget * widget=WFirst;
 while(widget)
 {
  WFirst=widget->WNext;
  delete widget;
  widget=WFirst;
 }
 this->GWidget::~GWidget();
}

void GGroup::HandleEvent(GEvent * event)
{
 GWidget * widget=WFirst;
 while(widget)
 {
  widget->HandleEvent(event);
  widget=widget->WNext;
 }
}

void GGroup::DrawWidget(void)
{
 GWidget * widget=WFirst;
 while(widget)
 {
  widget->Draw();
  widget=widget->WNext;
 }
}

void GGroup::Insert(GWidget * w)
{
 GWidget * widget;
 if(!w) return;
 w->Parent=this;
 if(!WFirst)
 {
  WFirst=w;
  w->WPrev=NULL;
  w->WNext=NULL;
  return;
 }
 for(widget=WFirst;widget->WNext;widget=widget->WNext);
 widget->WNext=w;
 w->WPrev=widget;
 w->WNext=NULL;
}

void GGroup::Remove(GWidget * w)
{
 if(w->WPrev) w->WPrev->WNext=w->WNext;
 if(w->WNext) w->WNext->WPrev=w->WPrev;
 if(w==WFirst)
  WFirst=w->WNext;
}

void GGroup::ForEach(void (*fn)(GGroup *,GWidget *,void *),void * priv)
{
 GWidget * widget;
 if(!fn) return;
 widget=WFirst;
 while(widget)
 {
  fn(this,widget,priv);
  widget=widget->WNext;
 }
}

void GGroup::Show()
{
 GWidget * widget=WFirst;
 this->GWidget::Show();
 while(widget)
 {
  widget->Show();
  widget=widget->WNext;
 }
}

void GGroup::Hide()
{
 GWidget * widget=WFirst;
 this->GWidget::Hide();
 while(widget)
 {
  widget->Hide();
  widget=widget->WNext;
 }
}

void GGroup::Select(GWidget * widg,bool sel)
{
 if(Parent)
 {
  Parent->Select(this,true);
 }
 if(WSelect)
  WSelect->Select(false);
 WSelect=widg;
 if(!WSelect) return;
 widg->Select(sel);
}

GWidget * GGroup::Select()
{
 GWidget * topsel,* w;
 topsel=Parent;
 if(topsel)
 {
  while(topsel->Parent)
   topsel=topsel->Parent;
 } else {
  topsel=this;
 }
 w=((GGroup *)topsel)->WSelect;
 for(;;)
 {
  if(!w) return NULL;
  if(w->IsGroup())
  {
   if(!((GGroup *)w)->WSelect) return w;
   w=((GGroup *)w)->WSelect;
   continue;
  }
  return w;
 }
}
 
bool GGroup::IsGroup()
{
 return true;
}

void GGroup::BroadcastEvent(GEvent * ev)
{
 HandleEvent(ev);
}
