#include<mgtk/bitmap.h>
#include<kos32sys.h>
#include<stdlib.h>
#include<stdio.h>
#include"string.h"

GImagePool::GImagePool(GRect * r):GWidget()
{
 SetBounds(r);
 image_data=(char *)malloc(Size.x*Size.y*3);
 scan_size=Size.x*3;
 image_size=Size.x*Size.y*3;
}

GImagePool::~GImagePool()
{
 free(image_data);
}

void GImagePool::DrawWidget()
{
 GPoint p={0,0};
 ToGlobal(&p);
 draw_bitmap(image_data,p.x,p.y,Size.x,Size.y);
}

void GImagePool::Write(unsigned long pos,unsigned long count,char * buffer)
{
 if(pos>=image_size) return;
 if((pos+count)>=image_size) count=image_size-pos;
 memcpy(image_data+pos,buffer,count);
}

void GImagePool::Load(FILE * f)
{
 fread(image_data,1,image_size,f);
}

void GImagePool::Save(FILE * f)
{
 fwrite(image_data,1,image_size,f);
}

void GImagePool::PutPixel(int x,int y,unsigned long color)
{
 unsigned long pos;
 int d0;
 if(x>=Size.x || y>=Size.y) return;
 pos=(y*scan_size)+(x*3)+((unsigned long)image_data);
 __asm__ __volatile__(
     "movw %w2,(%1)\n\t"
     "shrl $16,%2\n\t"
     "movb %b2,2(%1)\n\t"
     :"=r"(d0)
     :"r"(pos),"0"(color));
}
