#include<mgtk/text.h>
#include<string.h>
#include<stdlib.h>
#include<ctype.h>
#include<kos32sys.h>
#include<mgtk/pen.h>

GInputLine::GInputLine(GRect * r,char * init_str):GWidget()
{
 max_len=((r->w-4)/BIG_FONT_XSZ)-1;
 r->h=16;
 text_buffer=(char *)malloc(max_len+1);
 memset(text_buffer,0,max_len+1);
 if(init_str)
 {
  cur_pos=strlen(init_str);
  if(cur_pos>max_len)
   cur_pos=max_len;
  memcpy(text_buffer,init_str,cur_pos);
 } else cur_pos=0;
 SetBounds(r);
 vis=true;
}

GInputLine::~GInputLine()
{
 free(text_buffer);
}

void GInputLine::DrawWidget()
{
 GPen Pen(this);
 Pen.FillRect2(0,0,Size.x,Size.y,0xFFFFFF);
 Pen.Rect3d(0,0,Size.x,Size.y,RGB(127,157,185));
 Pen.WriteText(2,(Size.y-BIG_FONT_YSZ)/2,text_buffer,cur_pos,0x10000000);
 if(Flags&wf_Selected)
  Pen.FillRect2(2+(cur_pos*BIG_FONT_XSZ),3,BIG_FONT_XSZ,BIG_FONT_YSZ,0);
}

char * GInputLine::GetData()
{
 return text_buffer;
}

void GInputLine::HandleEvent(GEvent * ev)
{
 GWidget::HandleEvent(ev);
 if(ev->evType==GEVENT_CLICK)
 {
  GPoint p={0,0};
  ToGlobal(&p);
  if(MouseInWidget(ev->type.mouse.xMouse,ev->type.mouse.yMouse) &&
     ev->type.mouse.bMouse==1)
  {
   Parent->Select(this,true);
  } else {
   Parent->Select(this,false);
  }  
  Draw();
  return;
 }
 if(ev->evType==GEVENT_KEYBOARD && (Flags&wf_Selected))
 {
  int key=ev->type.key.keyId;
  if(key=='\r' || key=='\t' || key=='\n')
  {
   Parent->Select(this,false);
   Draw();
   ClearEvent(ev);
   return;
  }
  if(key=='\b')
  {
   if(cur_pos)
   {
    text_buffer[cur_pos]='\0';
    cur_pos--;
    Draw();
   }
   ClearEvent(ev);
   return;
  }
  if(isprint(key))
  {
   if(cur_pos>=max_len) return;
   text_buffer[cur_pos]=(key&0xff);
   cur_pos++;
   text_buffer[cur_pos]='\0';
   Draw();
   ClearEvent(ev);
   return;
  }
 }
}

void GInputLine::Idle()
{
 GWidget::Idle();
}
