#include<mgtk/pen.h>
#include<kos32sys.h>

GPen::GPen(GWidget * AWidget)
{
 GPoint p={0,0};
 AWidget->ToGlobal(&p);
 _dx=p.x;
 _dy=p.y;
}

GPen::~GPen()
{
}

void GPen::PutPixel(int x,int y,unsigned long color)
{
 PutPixel(x+_dx,y+_dy,color);
}

void GPen::Line(int x1,int y1,int x2,int y2,unsigned long color)
{
 draw_line(x1+_dx,y1+_dy,x2+_dx,y2+_dy,color);
}

void GPen::FillRect(int x1,int y1,int x2,int y2,unsigned long color)
{
 draw_bar(x1+_dx,y1+_dy,x2-x1+1,y2-y1+1,color);
}

void GPen::DrawLines(GPoint * plist,int nr_p,unsigned long color)
{
 GPoint prev;
 int i;
 prev.x=plist[0].x;
 prev.y=plist[0].y;
 for(i=1;i<nr_p;i++)
 {
  Line(prev.x,prev.y,plist[i].x,plist[i].y,color);
  prev.x=plist[i].x;
  prev.y=plist[i].y;
 }
}

void GPen::WriteText(int x,int y,char * buf,int len,unsigned long color)
{
 draw_text_sys(buf,x+_dx,y+_dy,len,color);
}

void GPen::Rect(int x1,int y1,int x2,int y2,unsigned long color)
{
 Line(x1,y1,x2,y1,color);
 Line(x1,y1,x1,y2,color);
 Line(x2,y1,x2,y2,color);
 Line(x1,y2,x2,y2,color);
}

void GPen::Rect3d(int x,int y,int w,int h,unsigned long color)
{
 GPoint p[3];
 p[0].x=x+1; p[0].y=y+h-1;
 p[1].x=x+w-1; p[1].y=y+h-1;
 p[2].x=x+w-1; p[2].y=y;
 DrawLines(p,3,RGB(255,255,255));
 p[0].x=x+2; p[0].y=y+h-2;
 p[1].x=x+w-2; p[1].y=y+h-2;
 p[2].x=x+w-2; p[2].y=y+1;
 DrawLines(p,3,RGB(192,192,192));  
 p[0].x=x; p[0].y=y+h-1;
 p[1].x=x; p[1].y=y;
 p[2].x=x+w-1; p[2].y=y;
 DrawLines(p,3,RGB(128,128,128));
 p[0].x=x+1; p[0].y=y+h-2;
 p[1].x=x+1; p[1].y=y+1;
 p[2].x=x+w-2; p[2].y=y+1;  
 DrawLines(p,3,RGB(0,0,0));
}

void GPen::FillRect2(int x1,int y1,int xsz,int ysz,unsigned long color)
{
 draw_bar(x1+_dx,y1+_dy,xsz,ysz,color);
}

void GPen::Line2(int x1,int y1,int xsz,int ysz,unsigned long color)
{
 draw_line(x1+_dx,y1+_dy,x1+xsz-1+_dx,y1+ysz-1+_dy,color);
}

void GPen::PutImage(int x,int y,int xsz,int ysz,char * buf)
{
 PutImage(x+_dx,y+_dy,xsz,ysz,buf);
}

void GPen::PutImage(int x,int y,struct GImageData * img)
{
 PutImage(x+_dx,y+_dy,img->w,img->h,(char *)img->data);
}
