#include<mgtk/slider.h>
#include<mgtk/pen.h>
#include"images/scroll_up.h"
#include"images/scroll_down.h"
#include"images/scroll_right.h"
#include"images/scroll_left.h"
#include"string.h"

extern "C" void __libclog_printf(const char * fmt,...);

GScroll::GScroll(GRect * r,int mode,unsigned long min,unsigned long max,
    unsigned long cur,unsigned long _delta)
    :GGroup()
{
 struct GImageData * i1,* i2;
 GRect q;
 SetBounds(r);
 mode&=(slider_Horizontal|slider_Vertical);
 delta=_delta;
 if(mode==slider_Horizontal)
 {
  i1=&scroll_left_image_data;
  i2=&scroll_right_image_data;
 } else {
  i1=&scroll_up_image_data;
  i2=&scroll_down_image_data;
 }
 q.Assign(0,0,i1->w,i1->h);
 b1=new GImageButton(&q,i1,cm_Scrollup);
 Insert(b1);
 if(mode==slider_Horizontal)
 {
  q.Assign(Size.x-i2->w,0,i2->w,i2->h);
 } else {
  q.Assign(0,Size.y-i2->h,i2->w,i2->h);
 }
 b2=new GImageButton(&q,i2,cm_Scrolldown);
 Insert(b2);
 if(mode==slider_Horizontal)
 {
  q.Assign(i1->w,0,Size.x-i1->w-i2->w,Size.y); 
 } else {
  q.Assign(0,i1->h,Size.x,Size.y-i1->w-i1->h);
 } 
 slider=new GSlider(&q,mode,min,max,cur);
 Insert(slider);
}

GScroll::~GScroll()
{
 this->GGroup::~GGroup();
}

void GScroll::HandleEvent(GEvent * ev)
{
 GGroup::HandleEvent(ev);
 if(IsDisabled()) return;
 if(ev->evType!=GEVENT_COMMAND) return;
 __libclog_printf("scroll: command=%u\n",ev->evType);
 switch(ev->type.command.evCommand)
 {
  case cm_Scrollup: {
   slider->SetCur(slider->GetCur()-delta);
   break;
  }
  case cm_Scrolldown: {
   slider->SetCur(slider->GetCur()+delta);
   break;
  }
  case cm_Scroll: {
  }
  default:
   return;
 }
 ev->evType=GEVENT_COMMAND;
 ev->type.command.evCommand=cm_Scroll;
 ev->type.command.info=(void *)slider;
 ev->type.command.info_long=slider->GetCur();
}
