#include<mgtk/slider.h>
#include<mgtk/pen.h>

GSlider::GSlider(GRect * r,int mode,unsigned long min,unsigned long max,unsigned long cur)
    :GWidget()
{
 SetBounds(r);
 SMode=mode;
 VSetMin(min);
 VSetMax(max);
 VSetCur(cur);
}

GSlider::~GSlider()
{
 this->GWidget::~GWidget();
}

void GSlider::VSetMin(unsigned long min)
{
 SMin=min;
}

void GSlider::VSetMax(unsigned long max)
{
 SMax=max;
}

void GSlider::VSetCur(unsigned long cur)
{
 SCur=cur;
}

void GSlider::SetMin(unsigned long min)
{
 VSetMin(min);
 Draw();
}

void GSlider::SetMax(unsigned long max)
{
 VSetMax(max);
 Draw();
}

void GSlider::SetCur(unsigned long cur)
{
 if(cur<SMin) cur=SMin;
 if(cur>SMax) cur=SMax;
 VSetCur(cur);
 Draw();
}

unsigned long GSlider::GetCur()
{
 return SCur;
}

unsigned long GSlider::GetMin()
{
 return SMin;
}

unsigned long GSlider::GetMax()
{
 return SMax;
}

void GSlider::DrawWidget()
{
 unsigned long v1,v2,pos,delta;
 GPen Pen(this);
 v1=(SMax-SMin);
 v2=(SCur-SMin)<<8;
 if(!v2 || !v1)
 {
  pos=0;
 } else {
  delta=SMode&slider_Solid?0:16;
  if(SMode&slider_Vertical)
  {
   pos=((v2*(Size.y-delta))/v1)>>8;
  } else {
   pos=((v2*(Size.x-delta))/v1)>>8;
  }
 }
 if(SMode&slider_Vertical)
 {
  Pen.FillRect2(0,0,16,Size.y,0xffffff);
  if(!(SMode&slider_Solid))
  {
   Pen.FillRect2(0,pos,16,16,0x808080);
  } else {
   Pen.FillRect2(0,0,16,pos,0x808080);
  }
 } else {
  Pen.FillRect2(0,0,Size.x,16,0xffffff);
  if(!(SMode&slider_Solid))
  {
   Pen.FillRect2(pos,0,16,16,0x808080);
  } else {
   Pen.FillRect2(0,0,pos,16,0x808080);
  }
 }
}

void GSlider::HandleEvent(GEvent * event)
{
 unsigned long v;
 GPoint p={0,0};
 GWidget::HandleEvent(event);
 if(IsDisabled() || !(Flags&wf_Visible)) return;
 ToGlobal(&p);
 if(event->evType==GEVENT_CLICK && event->type.mouse.bMouse==1)
 {
  if(MouseInWidget(event->type.mouse.xMouse,event->type.mouse.yMouse))
  {
   if(SMode&slider_Vertical)
   { 
    v=(event->type.mouse.yMouse-p.y)<<8;
    VSetCur((((v*(SMax-SMin))/Size.y)>>8)+SMin);
   } else {
    v=(event->type.mouse.xMouse-p.x)<<8;
    VSetCur((((v*(SMax-SMin))/Size.x)>>8)+SMin);
   }
  }  
  ClearEvent(event);
  event->evType=GEVENT_COMMAND;
  event->type.command.evCommand=cm_Scroll;
  event->type.command.info=(void *)this;
  event->type.command.info_long=SCur;
  Draw();
 }
}
