#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<mgtk/widget.h>

GWidget::GWidget()
{
 Flags=wf_Visible;
}

GWidget::~GWidget()
{
 if(Parent) Parent->Remove(this);
}

void GWidget::HandleEvent(GEvent * event)
{
 if(event->evType==GEVENT_IDLE && !(Flags&wf_Disabled))
 {
  Idle();
  return;
 }
 if(Flags&wf_Disabled) return;
 if(event->evType==GEVENT_COMMAND && event->type.command.evCommand==cm_Paint)
 {
  Draw();
  return;
 }
}

void GWidget::Draw(void)
{
 if(!(Flags&wf_Visible)) return;
 DrawWidget();
}

void GWidget::DrawWidget()
{
}

void GWidget::ToGlobal(GPoint * point)
{
 GPoint p;
 if(!Parent)
 {
  p.x=Origin.x;
  p.y=Origin.y;
 } else {
  p.x=0;
  p.y=0;
  Parent->ToGlobal(&p);
  p.x+=Origin.x;
  p.y+=Origin.y;
 }
 point->x+=p.x;
 point->y+=p.y;
}

void GWidget::ToLocal(GPoint * point)
{
 GPoint p;
 if(!Parent)
 {
  p.x=Origin.x;
  p.y=Origin.y;
 } else {
  p.x=0;
  p.y=0;
  Parent->ToLocal(&p);
  p.x+=Origin.x;
  p.y+=Origin.y;
 }
 point->x-=p.x;
 point->y-=p.y;  
}

void GWidget::Idle(void)
{
}

void GWidget::SetBounds(GRect * r)
{
 Origin.x=r->x;
 Origin.y=r->y;
 Size.x=r->w;
 Size.y=r->h;
}

void GWidget::ClearEvent(GEvent * ev)
{
 memset((void *)ev,0,sizeof(GEvent));
 ev->evType==GEVENT_NOTHING;
}

int GWidget::MouseInWidget(int x,int y)
{
 GPoint p;
 p.x=0;
 p.y=0;
 ToGlobal(&p);
 return ((x>=p.x && x<(p.x+Size.x)) && (y>=p.y && y<(p.y+Size.y)));
}

void GWidget::Show()
{
 if(Flags&wf_Visible) return;
 Flags|=wf_Visible;
}

void GWidget::Hide()
{
 if(!(Flags&wf_Visible)) return;
 Flags&=~wf_Visible;
}

void GWidget::Select(bool sel)
{
 if(sel)
  Flags|=wf_Selected;
 else
  Flags&=~wf_Selected;
}

bool GWidget::IsGroup()
{
 return false;
}
